'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.'''

import pygame
from pygame.locals import *
import sys
import data
from math import sin, cos, radians
from random import choice
from vector2d import vec2d
from image_loader import *


def EXIT(s=0):
    pygame.quit()
    sys.exit(s)

SCREENRECT = Rect(0,0,600,400)
FPS = 30
GRID_SIZE = 4
SP = 0.5 # Spread 

class Levelloader():
    def __init__(self,level=0):
        self.level = level
        
    def set(self,l):
        self.level = l
    
    def next(self, all_sp):
        self.level += 1
        self.clear(all_sp)
        SaveGame()
        self.load(self.level)
        
    def load(self,level):
        if level == 1: self.level1()
        elif level == 2: self.level2()
        elif level == 3: self.level3()
        elif level == 4: self.level4()
        elif level == 5: self.level5()
        elif level == 6: self.level6()
        elif level == 7: self.level7()
        elif level == 8: self.level8()
        elif level == 9: self.level9()
        elif level == 10: self.level10()
        elif level == 11: self.level11()
        else: 
            print 'You finished the game!'
            EXIT()
                
    def clear(self, all_sp):
        for s in all_sp.sprites():
            s.kill()
        
    def level1(self):
        Turret((500,366)) #366 367
        Feather((400,100))
        Container((350,260), [1])
        Container((330,260))
        Container((310,260))
        Container((290,260))
    
    def level2(self):
        Turret((500,367)) #366 367
        Container((240,280), [1])
        Container((220,280))
        Container((200,280))
        Container((180,280))
        Feather((460,100))
        Flying_barrel((485,120))
        
    def level3(self):
        Turret((500, 367))
        Container((500,260), [1])
        Container((520,260))
        Container((540,260))
        Container((560,260))
        Feather((280,40))
        
    def level4(self):
        Turret((500, 367))
        Container((240,280), [2])
        Container((220,280))
        Container((200,280))
        Container((180,280))
        Feather((480,70))
        Feather((320,20))
        
    def level5(self):
        Turret((500, 367))
        Container((440,260), [1])
        Feather((460,110))
        
    def level6(self):
        Turret((500, 367))
        Container((150,290), [1])
        Container((170,290))
        Container((190,290))
        Container((210,290))
        a = Feather((260,110))
        a.DOWN_SPEED = vec2d(0.08,0.2)
        a = Flying_barrel((260,120))
        a.WIND = vec2d(0.089,0.05)
        a = Flying_barrel((150,110))
        a.WIND = vec2d(0.08,0.05)
        a = Flying_barrel((170,130))
        a.WIND = vec2d(0.083,0.05)
        a = Flying_barrel((270,170))
        a.WIND = vec2d(0.075,0.05)

        
    def level7(self):
        Turret((500, 367))
        Container((490,280), [1])
        Container((510,280))
        Container((530,280))
        a = Feather((460,110))
        a.DOWN_SPEED = vec2d(-0.1,0.2)
        
    def level8(self):
        Turret((500, 367))
        Container((430,300), [1])
        Container((410,300))
        Container((390,300))
        a = Feather((50,50))
        a.DOWN_SPEED = vec2d(0.34,0.2)
        a = Flying_barrel((260,120))
        a.WIND = vec2d(0.24,0.055)
        a = Flying_barrel((40,270))
        a.WIND = vec2d(0.36,0.05)
        a = Flying_barrel((140,210))
        a.WIND = vec2d(0.23,0.045)
        a = Flying_barrel((100,200))
        a.WIND = vec2d(0.27,0.051)
        a = Flying_barrel((320,300))
        a.WIND = vec2d(0.25,0.056)
        a = Flying_barrel((130,70))
        a.WIND = vec2d(0.29,0.048)
        a = Flying_barrel((70,70))
        a.WIND = vec2d(0.28,0.049)

        
        
    def level9(self):
        Turret((500,366)) #366 367
        Feather((400,100))
        Container((550,280), [4])
        Container((530,280))
        Container((510,280))
        Container((490,280))
        Container((240,280))
        Container((220,280))
        Container((200,280))
        Container((180,280))
        Feather((460,100))
        Feather((270,140))
        Feather((410,270))
        
        
    def level10(self):
        Turret((500, 367))
        Container((430,300), [2])
        Container((410,300))
        Container((390,300))
        a = Feather((50,50))
        a.DOWN_SPEED = vec2d(0.34,0.2)
        a = Feather((70,50))
        a.DOWN_SPEED = vec2d(0.33,0.2)
        a = Flying_barrel((280,120))
        a.WIND = vec2d(0.20,0.055)
        a = Flying_barrel((40,80))
        a.WIND = vec2d(0.36,0.02)
        a = Flying_barrel((120,210))
        a.WIND = vec2d(0.235,0.045)
        a = Flying_barrel((307,200))
        a.WIND = vec2d(0.23,0.04)
        a = Flying_barrel((520,300))
        a.WIND = vec2d(0.253,0.0564)
        a = Flying_barrel((114,70))
        a.WIND = vec2d(0.295,0.048)
        a = Flying_barrel((64,70))
        a.WIND = vec2d(0.28,0.049)
        a = Flying_barrel((174,150))
        a.WIND = vec2d(0.26,0.0535)
        a = Flying_barrel((47,270))
        a.WIND = vec2d(0.357,0.05)
        a = Flying_barrel((90,213))
        a.WIND = vec2d(0.233,0.0445)
        a = Flying_barrel((20,175))
        a.WIND = vec2d(0.272,0.0451)
        a = Flying_barrel((520,300))
        a.WIND = vec2d(0.25,0.056)
        a = Flying_barrel((500,70))
        a.WIND = vec2d(0.239,0.0458)
        a = Flying_barrel((470,185))
        a.WIND = vec2d(0.218,0.0419)
        
    def level11(self):
        pass
        



class Flying_barrel(pygame.sprite.Sprite):
    WIND = vec2d(0.0,0.05) # Movement per frame
    def __init__(self,pos):
        self._layer = 0
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.image = load_image('balloon.png', -1)
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.pos = vec2d(pos)
        self.barrel = Barrel((pos),vec2d(0,1))
        self.barrel.sleep = 1
        self.barrel.rect.midtop = self.rect.midbottom
        self.barrel.pos = vec2d(self.barrel.rect.center)
        self.barrelpos = self.barrel.pos - self.pos
        # print self.barrelpos
        
        
    def destroy(self):
        try:
            self.barrel.sleep = 0
        except AttributeError: pass
        self.kill()
        
    def update(self):
        if not self.barrel.alive():
            self.destroy()
        pos = self.pos + self.WIND
        self.pos = pos
        self.rect.center = pos
        self.barrel.pos = self.barrelpos + pos
        self.barrel.rect.center = self.barrel.pos
        
        

class Feather(pygame.sprite.Sprite):
    DOWN_SPEED = (0, 0.2)  # And wind
    def __init__(self,pos,random=1):
        self._layer = 1
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.pos = pos
        self.oimage = load_image('feather.png', -1)
        self.image = self.oimage
        self.rect = self.image.get_rect()
        self.rect.center = self.pos
        self.velocity = vec2d(0,0)
        self.sleep = 0
        if random: self.c = choice(range(4,180,8)) # Counter for movement
        else: self.c = 0
        self.blocked = 0
        self.lastpos = 0
        # self.add = vec2d(0,0) # Adding this to position
            
    def update(self):
        global pa
        if self.sleep:
            return
        # print self.rect.top[1] , SCREENRECT.height
        if self.rect.top > SCREENRECT.height:
            game_over(self)
        if self.blocked:
            if self.lastpos == 0:
                self.lastpos = vec2d(self.pos)
            if self.lastpos != self.pos:
                self.blocked = 0
                self.lastpos = 0
                return
            self.velocity += get_vector_from_gridlist(pa,self.pos)
            self.velocity = (self.velocity*9 + self.DOWN_SPEED)*0.1
            self.pos += self.velocity-(0,0.4)
            self.rect.center = self.pos
            return
            
        self.c += 4.0
        if self.c > 720: self.c = 1.0
        self.image = pygame.transform.rotate(self.oimage, sin(radians(self.c*0.5))*18)
        self.velocity += get_vector_from_gridlist(pa,self.pos)
        self.velocity = (self.velocity*9 + self.DOWN_SPEED)*0.1
        self.pos += self.velocity
        # self.add = self.pos+(sin(radians(self.c*0.5)) * 12,cos(radians(self.c)) * 4)
        self.rect.center = self.pos + (sin(radians(self.c*0.5)) * 15,cos(radians(self.c)) * 4)

class Barrel(pygame.sprite.Sprite):
    GRAVITY = (0, 0.09) # How much gravity affects (weight?!)
    AIR_R = 0.03 # Air resistance
    P = 15000
    def __init__(self, pos, vel):
        self._layer = 2
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.pos = pos
        self.velocity = vel
        self.sound = load_sound('explosion.wav')
        self.oimage = load_image('expbarrel.png',-1)
        self.image = pygame.transform.rotate(self.oimage, 90-self.velocity.angle)
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.angle = 90-self.velocity.angle
        self.dangle = 360 
        self.sleep = 0
        
    def explode(self):
        global pa
        pa.append(Pressure_array((self.pos[0]-60,self.pos[1]-60,120,120)))
        l = pa[0::-1][0]
        x,y = self.pos
        l.add_to_pos(self.pos, self.P)
        l.add_to_pos((x-4,y), self.P)
        l.add_to_pos((x,y-4), self.P)
        l.add_to_pos((x-4,y-4), self.P)
        self.sound.play()
        self.kill()
    def add_explode(self, l):
        x,y = self.pos
        l.add_to_pos(self.pos, self.P)
        l.add_to_pos((x-4,y), self.P)
        l.add_to_pos((x,y-4), self.P)
        l.add_to_pos((x-4,y-4), self.P)
        self.sound.play()
        self.kill()
    
    # def collide(self, other):
        
        
    def update(self):
        t = test_gridlist_loc(pa, self.pos)
        if t:
            self.add_explode(t)
        if self.rect.bottom <= 0 or self.rect.top >= SCREENRECT.bottom or self.rect.left >= SCREENRECT.right or self.rect.right <= 0:
            self.kill()
        if self.sleep:
            return
        self.velocity = self.velocity + self.GRAVITY
        self.velocity.length = self.velocity.length - self.AIR_R
        # self.dangle = 360+ 90-self.velocity.angle # Problems with correct angle
        # self.angle = (self.dangle+self.angle*9)*0.1
        self.angle = 90-self.velocity.angle
        self.pos += self.velocity
        self.image = pygame.transform.rotate(self.oimage, self.angle)
        self.rect = self.image.get_rect()
        self.rect.center = self.pos

        
        
class STurret(pygame.sprite.Sprite):
    def __init__(self, pos):
        self._layer = 4
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.oimage = load_image('fan_base.png',-1)
        self.image = self.oimage
        self.rect = self.image.get_rect()
        self.rect.center = pos
        # self.font = 
        # self.fr = 
    def update(self):
        self.image = self.oimage.copy()
        self.image.blit(self.font, (0,self.rect.height-8) )
        
class Turret(pygame.sprite.Sprite):
    SHOTS_VEL = 0.03
    MAX_VEL = 9.2
    MIN_VEL = 4
    BAR_RELOAD = 133
    BC = 4
    GUN_RELOAD = 90
    def __init__(self, pos):
        self._layer = 3
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.st = STurret(pos)
        self.angle = 0
        self.mp = vec2d(1.0,1.0)
        self.rotation = 0
        self.oimage = load_image('fan.png',-1)
        self.gunpos = vec2d(0.0,-12.0)
        self.image = self.oimage
        self.rect = self.image.get_rect()
        self.pos = pos
        self.rect.center = pos
        self.breload = self.BAR_RELOAD
        self.greload = 0
        self.barrelc = self.BC
        # self.old = 0
        self.font = pygame.font.Font(data.filepath('04B_08__.TTF'),7)
        
        
        f = self.font.render('%.1f/100.0 %%'%(0),0,[0,255,0])
        self.st.font = f

        
    def shoot(self):
        if self.barrelc and len(pa) <= 1:
            if len(pa) == 1:
                if pa[0].c >= 166:
                    v = vec2d(1.0,1.0)
                    vel = self.SHOTS_VEL*self.mp.length
                    if vel > self.MAX_VEL:
                        vel = self.MAX_VEL
                    elif vel < self.MIN_VEL:
                        vel = self.MIN_VEL
                    v.length = vel
                    v.angle = -self.angle-180
                    Barrel(self.pos, v)
                    self.barrelc -= 1
            else:
                v = vec2d(1.0,1.0)
                vel = self.SHOTS_VEL*self.mp.length
                if vel > self.MAX_VEL:
                    vel = self.MAX_VEL
                elif vel < self.MIN_VEL:
                    vel = self.MIN_VEL
                v.length = vel
                v.angle = -self.angle-180
                Barrel(self.pos, v)
                self.barrelc -= 1
                
    def gun_shoot(self):
        if not self.greload:
            Shot(self.pos+self.gunpos,180-self.angle)
            self.greload = self.GUN_RELOAD

    def update(self):
        if not self.barrelc:
            self.breload -= 1
            if self.breload <= 0:
                self.barrelc = self.BC
                self.breload = self.BAR_RELOAD
        if self.greload:
            self.greload -= 1

        mp = pygame.mouse.get_pos()
        self.mp = vec2d(mp[0]-self.pos[0],mp[1]-self.pos[1])
        ang = -self.mp.angle
        if ang < 0:
            ang = 179.9
        elif ang < 80 and ang > 0:
            ang = 80.1
        self.angle = (ang-180+self.angle*9)*0.1
        self.gunpos.angle = 270-self.angle
        self.image = pygame.transform.rotate(self.oimage, self.angle)
        self.rect = self.image.get_rect()
        self.rect.center = self.pos # +vec2d(sin(radians(self.angle*2.0))*15.0,sin(radians(self.angle*2.0))*15.0) #14

        vel = self.SHOTS_VEL*self.mp.length
        if vel > self.MAX_VEL:
            vel = self.MAX_VEL
        elif vel < self.MIN_VEL:
            vel = self.MIN_VEL
        f = self.font.render('%.1f/100.0 %%'%((vel-self.MIN_VEL)/(self.MAX_VEL-self.MIN_VEL)*100),0,[0,0,0])
        self.st.font = f

        
class Shot(pygame.sprite.Sprite):
    SPEED = 14
    def __init__(self,pos,ang):
        self._layer = 1
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = load_image('shot.png',-1)
        self.image = pygame.transform.rotate(self.image, 270-ang) #####
        self.rect = self.image.get_rect()
        self.pos = pos
        self.rect.center = pos
        self.velocity = vec2d(1,1)
        self.velocity.length = self.SPEED
        self.velocity.angle = ang
        
    def update(self):
        self.pos += self.velocity
        self.rect.center = self.pos
        if self.rect.bottom <= 0 or self.rect.top >= SCREENRECT.bottom or self.rect.left >= SCREENRECT.right or self.rect.right <= 0:
            self.kill()
        
class Container(pygame.sprite.Sprite):
    def __init__(self,pos,extra=None):
        self._layer = 0
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.extra = extra   # Level data: [feathers_to_save]
        self.pos = pos
        self.image = pygame.Surface((20,12))
        self.grid = make_grid((0,0),xrange(0,3),xrange(0,5))
        self.grid[0][0][0].fill((100,100,100))
        self.grid[0][4][0].fill((100,100,100))
        self.grid[1][0][0].fill((100,100,100))
        self.grid[1][4][0].fill((100,100,100))
        self.grid[2][0][0].fill((100,100,100))
        self.grid[2][4][0].fill((100,100,100))
        self.grid[2][1][0].fill((100,100,100))
        self.grid[2][2][0].fill((100,100,100))
        self.grid[2][3][0].fill((100,100,100))
        
        self.grid[0][1][0].fill((200,255,200))
        self.grid[0][2][0].fill((200,255,200))
        self.grid[0][3][0].fill((200,255,200))
        self.grid[1][1][0].fill((200,255,200))
        self.grid[1][2][0].fill((200,255,200))
        self.grid[1][3][0].fill((200,255,200))
        for y in self.grid:
            for x in y:
                self.image.blit(x[0],x[1])
        self.rect = self.image.get_rect()
        self.num = 0
        self.rect.center = pos
        self.lock_timer = 15
    
    def collide(self,other):
        try: c = self.image.get_at((other.rect.center[0]-self.rect.topleft[0],other.rect.center[1]-self.rect.topleft[1]))
        except Exception, message:
            c = message
        if c == (100,100,100,255):
            other.blocked = 1
        elif c == (200,255,200,255):
            if isinstance(other, Feather):
                if other.sleep == 0:
                    # print self.num
                    other.sleep = None
                elif not other.sleep:
                    self.lock_timer -= 1
                    if self.lock_timer <= 0:
                        self.num += 1
                        other.sleep = 1
                        self.lock_timer = 15
        # else: print c
        
class Pressure_array():
    def __init__(self, r=None):
        '''Pressure_array( r ) r = (topleft_x, topleft_y, x, y) note: x and y need to be divided by GRID_SIZE  BEFORE calling!'''
        self.c = 0 # Counter set to 3 sec
        if r != None:
            self.size = [r[3]/GRID_SIZE,r[2]/GRID_SIZE]  # [y,x] #fail
            self.pos = (r[0],r[1])
        elif int(SCREENRECT.height)/int(GRID_SIZE) != float(SCREENRECT.height)/float(GRID_SIZE)\
            or int(SCREENRECT.width)/int(GRID_SIZE) != float(SCREENRECT.width)/float(GRID_SIZE):
            print int(SCREENRECT.height)/int(GRID_SIZE) , float(SCREENRECT.height)/float(GRID_SIZE)
            print int(SCREENRECT.width)/int(GRID_SIZE) , float(SCREENRECT.width)/float(GRID_SIZE)
        else: self.size = [SCREENRECT.height/GRID_SIZE,SCREENRECT.width/GRID_SIZE]; self.pos = (0,0)
        self.data = []
        self.y_xra = xrange(0,self.size[0])
        self.x_xra = xrange(0,self.size[1])
        self.p = make_grid(self.pos ,self.y_xra, self.x_xra) # list that holds grid images and rects
        self.center = vec2d(r[0]+r[2]*0.5, r[1]+r[3]*0.5)
        for y in xrange(0,self.size[1]):
            row = []
            for x in xrange(0,self.size[0]):
                row.append(0.0)  # [ pressure ] None = Block
            self.data.append(row)
    def get_from_pos(self, pos):
        try:
            return self.data[int(pos[1]-self.pos[1]*0.25)][int(pos[0]-self.pos[0]*0.25)]
        except IndexError: return None
    def get_from_s_pos(self, pos):
        try:
            y = int(pos[1]-self.pos[1]*0.25)
            x = int(pos[0]-self.pos[0]*0.25)
            if y < 0 or x < 0: return None
            return self.data[y][x]
        except IndexError: return None

    def set_to_pos(self, pos,value):
        try:
            self.data[int(pos[1]/4)][int(pos[0]/4)] = value
        except Exception: pass
    def add_to_pos(self, pos,value):
        try:
            self.data[int(pos[1]*0.25-self.pos[1]*0.25)][int(pos[0]*0.25-self.pos[0]*0.25)] += value
        except Exception: pass
    def update(self):
        self.c += 1
        new = []
        for y in self.y_xra:
            row = []
            for x in self.x_xra:
                if self.data[y][x] == None:
                    row.append(None)
                    continue
                num = 0.0
                div = 4
                dp = 0
                for i in [(y+1,x),(y,x+1),(y,x-1),(y-1,x)]:
                    try:
                        if i[0] < 0 or i[1] < 0:
                            continue
                        cur = self.data[i[0]][i[1]]
                    except IndexError:
                        continue
                    if cur == None:
                        div -= 1
                    else:
                        num += cur
                if div:
                    fnum = num / div * 0.5
                else:
                    fnum = 0
                    dp = 1
                num = 0.0
                div = 4
                for i in [(y+1,x+1),(y+1,x-1),(y-1,x-1),(y-1,x+1)]:
                    try:
                        if i[0] < 0 or i[1] < 0:
                            continue
                        cur = self.data[i[0]][i[1]]
                    except IndexError:
                        continue
                    if cur == None:
                        div -= 1
                    else:
                        num += cur
                if div:
                    fnum += num / div *0.5 
                else:
                    if dp:
                        fnum = self.data[i[0]][i[1]]
                row.append(fnum)
                        
            new.append(row)
        self.data = new

       

       
class MainMenu():
    textcolor = [100,0,0]
    mouseover_color = [255,0,0]
    def __init__(self):
        Feather((245,200))
        Feather((60,100))
        Feather((482,150))
        Feather((311,370))
        Feather((131,268))
        
        
        self.titlefont = pygame.font.Font(data.filepath('04B_08__.TTF'),28)
        self.font = pygame.font.Font(data.filepath('04B_08__.TTF'),12)
        self.objects = []  # [ <image>, <mouseover_image>, <rect>, <num> ]  # state: 1= mouseover, 0 = normal
        cen = SCREENRECT.width/2
        
        img = self.titlefont.render('Feather Menace',0,self.textcolor)
        rec = img.get_rect()
        rec.center = (cen,80)
        self.objects.append([img,img,rec,0])

        
        img = self.font.render('New Game',0,self.textcolor)
        mou = self.font.render('New Game',1,self.mouseover_color)
        rec = img.get_rect()
        rec.center = (cen,200)
        self.objects.append([img,mou,rec,1])
        
        img = self.font.render('Continue',0,self.textcolor)
        mou = self.font.render('Continue',1,self.mouseover_color)
        rec = img.get_rect()
        rec.center = (cen,250)
        self.objects.append([img,mou,rec,2])

        img = self.font.render('Exit',0,self.textcolor)
        mou = self.font.render('Exit',1,self.mouseover_color)
        rec = img.get_rect()
        rec.center = (cen,300)
        self.objects.append([img,mou,rec,3])
        
        self.opened = 1
        global Main_menu
        Main_menu = 1
        
    def update(self, screen, all_sp):
        if self.opened:
            ms = pygame.mouse.get_pos()
            gp = pygame.mouse.get_pressed()[0]
            for x in self.objects:
                if x[2].collidepoint(ms):  # Mouseover
                    if gp:
                        if x[3] == 1:
                            self.close(all_sp)
                            NewGame()
                        elif x[3] == 2:
                            self.close(all_sp)
                            LoadGame()
                        elif x[3] == 3:
                            self.close(all_sp)
                            EXIT()
                    else:
                        screen.blit(x[1],x[2])
                else:
                    screen.blit(x[0],x[2])
            
    def close(self,all_sp):
        self.opened = 0
        global Main_menu
        Main_menu = 0
        for s in all_sp.sprites():
            s.kill()
    
    def open(self,show_feathers=1):
        self.opened = 1
        global Main_menu
        Main_menu = 1
        if show_feathers:
            Feather((245,200))
            Feather((60,100))
            Feather((482,150))
            Feather((311,370))
            Feather((131,268))
    
    
def NewGame():

    file = open('savegame.dat','w')
    file.write('0')
    file.close()
    ll.set(1)
    ll.load(1)
    
def LoadGame():
    # ll.load(10)
    # return
    try: 
        file = open(data.filepath('savegame.dat'),'r')
        l = file.read()
    except Exception:
        l = 0
    file.close()
    l = int(l)
    if l:
        ll.set(l)
        ll.load(l)
    else:
        ll.set(1)
        ll.load(1)
        
def SaveGame():
    l = str(ll.level)
    file = open(data.filepath('savegame.dat'),'w')
    file.write(l)
    file.close()
    
    
def game_over(o):
    if Main_menu:
        if isinstance(o, Feather):
            o.pos = vec2d(o.rect.center[0],0)
            o.rect.center = o.pos
    else:
        # print 'Game Over'
        global all_sp
        ll.clear(all_sp)
        list = [
        [0,0,8,8,0,0,0,8,8,0,0,8,0,0,0,8,0,8,8,8,0,0,8,8,8,8,0,8,0,0,0,8,0,8,8,8,0,8,8,8,0,0],
        [0,8,0,0,8,0,8,0,0,8,0,8,8,0,8,8,0,8,0,0,0,0,8,0,0,8,0,8,0,0,0,8,0,8,0,0,0,8,0,0,8,0],
        [0,8,0,0,0,0,8,0,0,8,0,8,0,8,0,8,0,8,8,8,0,0,8,0,0,8,0,0,8,0,8,0,0,8,8,8,0,8,0,0,8,0],
        [0,8,0,8,8,0,8,8,8,8,0,8,0,0,0,8,0,8,0,0,0,0,8,0,0,8,0,0,8,0,8,0,0,8,0,0,0,8,8,8,0,0],
        [0,8,0,0,8,0,8,0,0,8,0,8,0,0,0,8,0,8,0,0,0,0,8,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8,0,0,8,0],
        [0,0,8,8,0,0,8,0,0,8,0,8,0,0,0,8,0,8,8,8,0,0,8,8,8,8,0,0,0,8,0,0,0,8,8,8,0,8,0,0,0,8,]]
        xran = xrange(0,len(list[0]))
        for y in xrange(0,len(list)):
            for x in xran:
                if list[y][x]:
                    Feather((x*14+10,y*14+10),0)
                    menu.open(0)
            
        
        


def make_grid(pos, pay, pax):
    p = []
    for y in pay: 
        r = []
        for x in pax:
            sur = pygame.Surface((GRID_SIZE,GRID_SIZE))
            rec = sur.get_rect()
            rec.topleft = (pos[0]+x*4,pos[1]+y*4)
            sur.fill((255,255,255))
            r.append((sur,rec))
        p.append(r)
    return p
    
def get_vector_from_gridlist(list, pos):
    sum = vec2d(0,0)
    po = (pos[0]*0.25,pos[1]*0.25)
    for l in list: 
        g = l.get_from_s_pos(po)
        if g == None: return 0 # None ## Changed ##
        elif g > 0:
            v = (pos - l.center).normalized()
            v.length = v.length + g*0.0001
            sum += v
    return sum
    
def get_from_gridlist(list, pos):
    sum = 0
    po = (pos[0]*0.25,pos[1]*0.25)
    for l in list: 
        try: 
            sum += l.get_from_s_pos(po)
        except TypeError: continue
    return sum
    
def test_gridlist_loc(list, pos):
    sum = 0
    po = (pos[0]*0.25,pos[1]*0.25)
    for l in list:
        g = l.get_from_s_pos(po)
        if g == None: return None
        if g > 120:
            return l
    return False
            
def main():
    
    pygame.init()
    icon = pygame.image.load(data.filepath('feather_icon.png'))
    pygame.display.set_icon(icon)
    screen = pygame.display.set_mode(SCREENRECT.size,DOUBLEBUF)
    pygame.display.set_caption('Feather Menace')
    
    bg = pygame.Surface(SCREENRECT.size)
    bgrect = bg.get_rect()
    bg.fill((255,255,255))
    clock = pygame.time.Clock()
    # Groups:
    turrets = pygame.sprite.Group()
    feathers = pygame.sprite.Group()
    barrels = pygame.sprite.Group()
    shots = pygame.sprite.Group()
    conts = pygame.sprite.Group()
    fly_barrels = pygame.sprite.Group()
    global all_sp
    all_sp = pygame.sprite.LayeredUpdates()
    
    Feather.containers = feathers, all_sp
    Barrel.containers = barrels, all_sp
    Turret.containers = turrets, all_sp
    STurret.containers = all_sp
    Shot.containers = shots, all_sp
    Container.containers = conts, all_sp
    Flying_barrel.containers = fly_barrels, all_sp
    # Game objects:
    global ll
    ll = Levelloader(0)
    # ll.load(1)
    global menu
    menu = MainMenu()
    global Main_menu
    Main_menu = 1
    global pa
    pa = []
    # #######   - MAINLOOP  - ########
    while 1:
        clock.tick(FPS)
        screen.blit(bg, bgrect)
        
        b = 0
        e = [0]
        if not Main_menu:
            for c in conts.sprites():
                b += c.num
                if c.extra: e = c.extra
            if b >= e[0]:
                ll.next(all_sp)
        # ########## INPUT ##########
        for e in pygame.event.get():
            if e.type == QUIT:
                EXIT()
            elif e.type == KEYDOWN:
                if e.key == K_ESC:
                    menu.open()
            elif e.type == MOUSEBUTTONDOWN:
                if e.button == 1:
                    for t in turrets.sprites():
                        t.shoot()
                elif e.button == 3:
                    for t in turrets.sprites():
                        t.gun_shoot()
        # pmgp = pygame.mouse.get_pressed()
        # e = pygame.mouse.get_pos()
        # if pmgp[0]:
        # elif pmgp[1]: 
        # elif pmgp[2]:
        # ###################
        # ##### COLLISION: ######
        for s, bl in pygame.sprite.groupcollide(shots,barrels,1,0).items():
            for b in bl:
                b.explode()
        for s, fl in pygame.sprite.groupcollide(shots,fly_barrels,1,0).items():
            for f in fl:
                f.destroy()
        for c, bl in pygame.sprite.groupcollide(conts,barrels,0,0).items():
            for b in bl:
                b.explode()
        for c, fe in pygame.sprite.groupcollide(conts,feathers,0,0).items():
            for f in fe:
                c.collide(f)
        
        # ###################
        for g in xrange(0,len(pa)):
            try: 
                if pa[g].c >= 200:
                    del pa[g]
            except IndexError:
                try:
                    if pa[g-1].c >= 200:
                        del pa[g-1]
                except:
                    del pa
                    pa = []


        for g in pa:
            g.update()
            pay = g.y_xra
            pax = g.x_xra
            p = g.p
            pos = g.pos
            for y in pay: 
                for x in pax:
                    sr = p[y][x]
                    d = get_from_gridlist(pa,(x*4+pos[0],y*4+pos[1]))
                    if d == None:
                        sr[0].fill((100,100,100))
                        screen.blit(sr[0],sr[1])
                        continue
                    d *= 0.5
                    try: sr[0].fill((255,255,255-d))
                    except TypeError:
                        try: 
                            d -= 255
                            sr[0].fill((255,255-d,0))
                        except TypeError: sr[0].fill((255,0,0))
                    screen.blit(sr[0],sr[1])
                    
        all_sp.update()
        all_sp.draw(screen)
        menu.update(screen, all_sp)
        pygame.display.flip()
        
        # END OF MAINLOOP #
try:
    import psyco
    psyco.bind(Pressure_array.update)
    psyco.bind(main)
except ImportError:
    pass
    
# import profile
# profile.run('main()')
if __name__ == '__main__': 
    main()